n = int(input())
ll = input()
rozw = {}
def R(pocz,kon):
    if pocz>kon: return 0
    if pocz==kon: return 1
    if (pocz, kon) in rozw: return rozw[(pocz,kon)]
    odp = R(pocz, kon-1)+1
    for k in range(pocz,kon):
        if ll[k]==ll[kon]:
            odp = min(odp, R(pocz, k-1)+max(R(k+1, kon-1),1))
    mm[(pocz,kon)] = odp
    return odp

print( R(0, n-1) )
